<?php
/**
 * Plugin Name: Contact Form 7 API Sender For ZNICRM
 * Plugin URI: https://znicrm.com
 * Author: Intueri Inc.
 * Author URI: https://intueri.io
 * Description: This plugin will automatically create a CRM lead from the Contact Form 7 form submission.
 * Version: 0.1.0
 * License: Free
 * text-domain: prefix-plugin-name
 */

 
 
if (!function_exists('write_log')) {

    function write_log($log) {
        if (true === WP_DEBUG) {
            if (is_array($log) || is_object($log)) {
                error_log(print_r($log, true));
            } else {
                error_log($log);
            }
        }
    }

}
 function znicrm_contactform7_sender($contact_form,$abort, $submission){
 	// Change the API Key of the ZNICRM. You can get it from Settings -> Global -> API Key
 	$znicrm_apikey = "";
 	//Change the department ID if you want to send it to specific department
 	$znicrm_department_id = 0; 
 
    $form_id = $contact_form->id();
	 $form_title = $contact_form->title();
    //$submission = WPCF7_Submission::get_instance();
    if($submission){
		if(empty($znicrm_apikey)){
			write_log("ZNICRM Apikey is missing");
			return;
		}
        $posted_data = $submission->get_posted_data();
        $name = isset($posted_data["your-name"])?$posted_data["your-name"]:"";
        $email = isset($posted_data["your-email"])?$posted_data["your-email"]:"";
        $subject = isset($posted_data["your-subject"])?$posted_data["your-subject"]:"";
        $message = isset($posted_data["your-message"])?$posted_data["your-message"]:"";
		$phone = isset($posted_data["your-phone"])?$posted_data["your-phone"]:"";
		
		$args = [];
		$args["apikey"] = urlencode($znicrm_apikey);
		$args["leadName"] = urlencode($name);
		$args["leadEmail"] = urlencode($email);
		$args["leadPhone"] = urlencode($phone);
		$args["department"] = urlencode($znicrm_department_id);
		$args["leadQuery"] = urlencode( $subject ."#*# Message: ". $message ."#*# Form Title: ". $form_title);
		
		$arg = "";
		foreach($args as $x => $val){
			$arg = $arg. $x ."=". $val ."&";
		}
		$url = "https://api.intueri.io/weblead.php?$arg";
		write_log($url);
		$response = wp_remote_get( $url);
		if ( is_array( $response ) && ! is_wp_error( $response ) ) {
			$headers = $response['headers']; // array of http header lines
			$body    = $response['body']; // use the content
			write_log($body);
		}else{
			write_log("Failed request");
		}
		
    }else{
		write_log("Submission is not valid and failed");
	}
   
 }
function my_skip_mail() {
	// set it to true if you want to skip sending the email
    return false; 
}
add_filter('wpcf7_skip_mail','my_skip_mail');
add_filter('wpcf7_before_send_mail','znicrm_contactform7_sender',10,3);